#delimit ;
cap program drop ghkint;
program define ghkint;
version 5.0;
     if "`1'"=="" {;
        di _col(5) in w "Form of call to ghkint:"
           _n _col(10)
              in w "ghkint " in b "prob id d u l Q d " in g "R fi li " in y "ch"
           _n _col(10) in w "variables"
           _n _col(15) in b "prob " _col(22)  in w "OUTPUT variable, probability of area for each id"
           _n _col(15) in b "id " _col(22) in w "variable indicating different observations"
           _n _col(15) in b "d  " _col(22) in w "dimension of integral variable"
           _n _col(15) in b "u  " _col(22) in w "upper bound on d "
           _n _col(15) in b "l  " _col(22) in w "lower bound on d "
           _n _col(15) in b "Q  " _col(22) in w "type of interval (-1,0,1,2,3)"
           _n _col(10) in w "integer values"
           _n _col(15) in g "R " _col(22)  in w " # of replications"
           _n _col(15) in g "fi " _col(22) in w "lowest value of d variable"
           _n _col(15) in g "li " _col(22) in w "highest value of d variable"
           _n _col(10) in w "existing matrix variable"
           _n _col(15) in y "ch " _col(22) in w "cholesky matrix"
           _n;
        exit;
        };
     loc prob = "`1'";
     loc id = "`2'";
     loc d  = "`3'";
     loc u = "`4'";
     loc l = "`5'";
     loc Q = "`6'";
     if "`7'"=="" | "`7'"=="." {; loc R = 1;}; else {;loc R = `7';};
     qui summ `d';
     if "`8'"=="" | "`8'"=="." {;loc fi = _result[5];}; else {;loc fi = `8';};
     if "`9'"=="" | "`9'"=="." {;loc li = _result[5];}; else {;loc li = `9';};
     if "`10'"=="" | "`10'"=="." {;
        tempname ch;
        loc n = `li'-`fi';
        matrix ch = I(`n');
        };
     else {;
        loc ch = `10';
        };
	tempvar w1 w2 FU1 FL1 FU2 FL2 a1  a2 b1 b2 like1 like2 e1 e2 ;
     tempname rt c;
     qui {;
     cap drop `prob';
     gen double `prob' = 0.0;
     gen double `like1' = 0.0;
     gen double `like2' = 0.0;
     gen double `FU1' = 0.0;
     gen double `FU2' = 0.0;
     gen double `FL1' = 0.0;
     gen double `FL2' = 0.0;
     gen double `e1' = 0.0;
     gen double `e2' = 0.0;
     gen `w1' = 0.0;
     gen `w2' = 0.0;
     gen double `a1' = 0.0;
     gen double `a2' = 0.0;
     gen double `b1' = 0.0;
     gen double `b2' = 0.0;
     sca `rt' = 1/(2*`R');
     };
     loc r = 1;
     sort `id' `d';
     while `r' <= `R' {;
           qui {;
           replace `like2' = 1.0;
           replace `like1' = 1.0;
	      replace `w1'= uniform();
           replace `w2'= 1-`w1';
           loc i = `fi';
           while `i' <= `li' {;
                 loc f = `i'-`fi'+1;
  	            replace `b1' = `u' ;
                 replace `a1' = `l' ;
	            replace `b2' = `u' ;
                 replace `a2'= `l' ;
                 loc m = 1;
                 while `f'-`m' >= 1 {;
                     loc j = `f'-`m';
                     sca `c' = `chol'[`f',`j']/`chol'[`f',`f'];
                     replace `b1'=`b1'-`c'*`e1'[_n-`m'] if `d'==`i';
                     replace `a1'=`a1'-`c'*`e1'[_n-`m'] if `d'==`i';
                     replace `b2'=`b2'-`c'*`e2'[_n-`m'] if `d'==`i';
                     replace `a2'=`a2'-`c'*`e2'[_n-`m'] if `d'==`i';
                     loc m = `m' + 1;
	                };
                 replace `FL1' = 0.0  ;
                 replace `FL2' = 0.0  ;

                 replace `FU1'=cond(`Q'<0,normd(`b1')/`chol'[`f',`f'],1.0);
                 replace `FU2'=cond(`Q'<0,normd(`b2')/`chol'[`f',`f'],1.0);

                 replace `FU1'=normprob(`b1') if (`Q'==0 | `Q'==1);
                 replace `FL1'=normprob(`a1') if (`Q'==0 | `Q'==2);

                 replace `FU2'=normprob(`b2') if (`Q'==0 | `Q'==1);
                 replace `FL2'=normprob(`a2') if (`Q'==0 | `Q'==2);
                 if `i' < `li' {;
                    replace `e1'= cond(`Q'<0,`b1',invnorm(`w1'*`FU1'+`w2'*`FL1'));
                    replace `e2'= cond(`Q'<0,`b2',invnorm(`w2'*`FU2'+`w1'*`FL2'));
                    };
                 replace `like1' = (`FU1'-`FL1')*`like1';
                 replace `like2' = (`FU2'-`FL2')*`like2';
                 loc i = `i' + 1;
   	            } /* for i loop */;
 	      replace `prob' = (`like1'+`like2')*`rt' +`prob';
           };
           if mod(`r'/`R',.1)==0 {; di in b "." _cont; };
           loc r = `r' + 1;
	      } /* end R loop */  ;
end;

